#include<bits/stdc++.h>

using namespace std;
typedef long long ll;

const int maxn = 2e5 + 10;

int n, m, c[maxn], d[maxn];

vector < int > adj[maxn];
vector < int > have_color[maxn], need_color[maxn];
pair < int, int > road[maxn];
void input()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i ++)
    {
        cin >> c[i];
        have_color[c[i]].push_back(i);
    }
    for (int i = 1; i <= n; i ++)
    {
        cin >> d[i];
        need_color[d[i]].push_back(i);
    }
    for (int i = 1; i <= m; i ++)
    {
        int v, u;
        cin >> v >> u;
        road[i] = {v, u};
        adj[v].push_back(u);
        adj[u].push_back(v);
    }
}

void clear_data()
{
    for (int i = 1; i <= n; i ++)
    {
        need_color[i].clear();
        have_color[i].clear();
        adj[i].clear();
    }
}

struct dsu_save
{
    int v, u, par_v, par_u;
    int rnk_v, rnk_u;

    dsu_save(int _v, int _u, int _par_v, int _par_u, int _rnk_v, int _rnk_u)
    {
        v = _v;
        u = _u;
        par_v = _par_v;
        par_u = _par_u;
        rnk_v = _rnk_v;
        rnk_u = _rnk_u;
    }
};



vector < pair < int, int > > tree[4 * maxn];
int par[maxn], rnk[maxn];

bool possible[maxn];
struct dsu_with_rollback
{
    stack < dsu_save > op;

    dsu_with_rollback(int n)
    {
        for (int i = 1; i <= 4 * n; i ++)
            tree[i].clear();
        for (int i = 1; i <= n; i ++)
        {
            par[i] = i;
            rnk[i] = 1;
        }
    }

    int find_leader(int v)
    {
        if (v == par[v])
            return v;
        return (find_leader(par[v]));
    }
    
    bool unite(int v, int u)
    {
        v = find_leader(v);
        u = find_leader(u);
        if (v == u)
            return false;

        op.push(dsu_save(v, u, par[v], par[u], rnk[v], rnk[u]));
        
        if (rnk[v] > rnk[u])
            swap(v, u);
        par[v] = u;
        rnk[u] += rnk[v];

        return true;
    }

    void update(int root, int left, int right, int qleft, int qright, pair < int, int > val)
    {
        if (left > qright || right < qleft)
            return;

        if (left >= qleft && right <= qright)
        {
            tree[root].push_back(val);
            return;
        }

        int mid = (left + right) / 2;
        update(root * 2, left, mid, qleft, qright, val);
        update(root * 2 + 1, mid + 1, right, qleft, qright, val);
    }

    void dfs(int root, int left, int right)
    {
        int cnt = 0;
        for (pair < int, int > cur : tree[root])
        {
            if (unite(cur.first, cur.second))
                cnt ++;
        }


        if (left == right)
        {
            unordered_set < int > fine;
            for (int cur : have_color[left])
                fine.insert(find_leader(cur));

            for (int cur : need_color[left])
            {
                if (fine.count(find_leader(cur)) > 0)
                    possible[cur] = 1;
            }
        }
        else
        {

            int mid = (left + right) / 2;
            dfs(root * 2, left, mid);
            dfs(root * 2 + 1, mid + 1, right);
        }
        while(cnt > 0)
        {
            cut();
            cnt --;
        }
    }

    void cut()
    {
        dsu_save ds = op.top();
        op.pop();
        par[ds.v] = ds.par_v;
        par[ds.u] = ds.par_u;
        rnk[ds.v] = ds.rnk_v;
        rnk[ds.u] = ds.rnk_u;
    }
};



int used[maxn];
void simulate()
{
    for (int i = 1; i <= n; i ++)
        possible[i] = 0;

    dsu_with_rollback dwr(n);

    for (int i = 1; i <= m; i ++)
    {
        int lf = max(d[road[i].first], d[road[i].second]);
        int rf = min(c[road[i].first], c[road[i].second]);
        if (lf <= rf)
        {
            dwr.update(1, 1, n, lf, rf, {road[i].first, road[i].second});
        }
    }

    dwr.dfs(1, 1, n);

    /**for (int t = 1; t <= n; t ++)
    {
        for (int i = 1; i <= n; i ++)
        {
            used[i] = 0;
        }

        queue < int > q;
        for (int i = 1; i <= n; i ++)
        {
            if (c[i] == t && d[i] <= t)
            {
                used[i] = 1;
                q.push(i);
            }
        }

        while(!q.empty())
        {
            int v = q.front();
            q.pop();

            for (int u : adj[v])
            {
                if (used[u] == 0 && d[u] <= t && c[u] >= t)
                {
                    used[u] = 1;
                    q.push(u);
                }
            }
        }

        for (int i = 1; i <= n; i ++)
        {
            if (d[i] == t && used[i] == 1)
                possible[i] = 1;
        }
    }*/

    bool done = true;
    for (int i = 1; i <= n; i ++)
    {
        if (possible[i] == false)
        {
            done = false;
            break;
        }
    }

    cout << done << endl;
}
void solve()
{
    input();
    simulate();
    clear_data();    
}

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int main()
{
    speed();
    int t;
    cin >> t;
    while(t --)
        solve();
    return 0;
}
/**
2
4 4
3 3 2 1
2 1 2 1
1 2
2 3
3 4
4 2
4 4
3 3 2 1
1 2 2 1
1 2
2 3
3 4
4 2

*/