#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstring>
#include <fstream>
#include <vector>
#include <random>
#include <map>

bool ran;
bool success;
int first[1 << 13];
int second[1 << 13];
std::mt19937 rng(69420); //std::chrono::stadytime_since_epoch()
std::vector <int> v[1 << 13];
int keys[13][13][13][13];

inline int get(int mask1, int mask2)
{
    return __builtin_ctz(((1 << 13) - 1) ^ mask1 ^ mask2);
}

std::pair <int,int> assistant1 (std::vector <int>& cards);
std::pair <int,int> assistant2 (std::vector <int>& cards);

std::pair <int,int> assistant[1 << 13];

void tryRun()
{
    ran = true;
    std::vector <int> masks;
    for (int mask = 0 ; mask < (1 << 13) ; ++mask)
    {
        if (__builtin_popcount(mask) != 6)
        {
            continue;
        }

        for (int i = 0 ; i < 13 ; ++i)
        {
            if (mask & (1 << i))
            {
                v[mask].push_back(i);
            }
        }

        masks.push_back(mask);
    }

    while (!success)
    {
        std::cout << "." << std::flush;
        memset(keys, -1, sizeof(keys));

        int idx = 0;
        success = true;
        for (const int &mask : masks)
        {
            for (int tries = 0 ; tries < 500 ; ++tries)
            {
                first[mask] = rng() % 6;
                second[mask] = rng() % (6 - 1);
                if (second[mask] >= first[mask]) second[mask]++;
                assistant[mask] = assistant1(v[mask]);
                
                bool isOK = true;
                for (int m2 = 0 ; m2 < idx ; ++m2)
                {
                    if (keys[assistant[mask].first][assistant[mask].second][assistant[masks[m2]].first][assistant[masks[m2]].second] != -1 && keys[assistant[mask].first][assistant[mask].second][assistant[masks[m2]].first][assistant[masks[m2]].second] != get(mask, masks[m2]))
                    {
                        isOK = false;
                        break;
                    }
                }

                if (isOK)
                {
                    // std::cout << "set\n";
                    for (int m2 = 0 ; m2 < idx ; ++m2)
                    {
                        keys[assistant[mask].first][assistant[mask].second][assistant[masks[m2]].first][assistant[masks[m2]].second] = get(mask, masks[m2]);
                    }

                    break;
                }

                if (tries == 499)
                {
                    continue;
                }
            }

            if (!success)
            {
                break;
            }

            idx++;
        }
    }

    if (success)
    {
        std::ofstream fout("sols.txt");
        for (const int &mask : masks)
        {
            fout << "first[" << mask << "] = " << first[mask] << ";\n";
            fout << "second[" << mask << "] = " << second[mask] << ";\n";
        }

        fout.close();
    }

    // std::cout << "success: " << success << "!\n";
}

std::pair <int,int> assistant1 (std::vector <int>& cards) 
{
    if (!ran) tryRun();
    // std::cout << "done run\n";
    int mask = 0;
    std::sort(cards.begin(), cards.end());
    for (const int &val : cards)
    {
        mask |= (1 << val);
    }

    return {cards[first[mask]], cards[second[mask]]};
}

std::pair <int,int> assistant2 (std::vector <int>& cards) 
{
    if (!ran) tryRun();
    int mask = 0;
    std::sort(cards.begin(), cards.end());
    for (const int &val : cards)
    {
        mask |= (1 << val);
    }

    // assert(__builtin_popcount(mask) == 6);
    // assert(0 <= mask && mask < (1 << 13));
    // assert(first[mask] != second[mask]);
    return {cards[first[mask]], cards[second[mask]]};
}

int magician (int N, std::pair <int,int> chosen1, std::pair <int,int> chosen2)
{
    return keys[chosen1.first][chosen1.second][chosen2.first][chosen2.second];
}