#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>
#include <set>

typedef long long llong;
const int MAXN = 100000 + 10;
const int MOD = 1e9 + 7;

int n, d;
struct Value
{
    int l, w;
    void fix()
    {
        if (l >= MOD) l -= MOD;
        if (w >= MOD) w -= MOD;
    }

    friend Value operator + (const Value &left, const Value &right)
    {
        Value result;
        result.l = left.l + right.l;
        result.w = left.w + right.w;
        result.fix();
        return result;
    }

    friend Value operator - (const Value &left, const Value &right)
    {
        Value result;
        result.l = left.l + MOD - right.l;
        result.w = left.w + MOD - right.w;
        result.fix();
        return result;
    }
};

int sz[MAXN];
bool win[MAXN];
int cntLose[MAXN];
Value dpW[MAXN];
Value dpL[MAXN];
Value coefsL, coefsW;
std::vector <int> g[MAXN];

void dfs(int node, int par)
{
    int cnt = 0;
    int v = 0;

    sz[node] = 1;
    cntLose[node] = 0;
    for (const int &u : g[node])
    {
        if (u == par)
        {
            continue;
        }

        dfs(u, node);
        sz[node] += sz[u];
        win[node] |= !win[u];
        cntLose[node] += !win[u];

        if (!win[u])
        {
            v = u;
        }
    }

    if (cntLose[node] >= 2)
    {
        dpL[node] = {0, 0};
    } else if (cntLose[node] == 1)
    {
        dpL[node] = dpW[v];
    } else
    {
        dpL[node] = {0, 0};
        dpL[node].w = 1;
        for (const int &u : g[node])
        {
            if (u == par)
            {
                continue;
            }

            dpL[node] = dpL[node] + dpW[u];
        }
    }

    dpW[node].w = sz[node];
    dpW[node].l = sz[node];
    dpW[node] = dpW[node] - dpL[node];
}

void dfsUp(int node, int par)
{
    if (node != 1)
    {
        win[node] |= (cntLose[par] == 1);
    }

    for (const int &u : g[node])
    {
        if (u == par)
        {
            continue;
        }

        dfsUp(u, node);
    }
}

void solve()
{   
    dfs(1, 0);
    dfsUp(1, 0);
    // return;

    int w = 0, l = 0;
    for (int i = 1 ; i <= n ; ++i)
    {
        w += win[i];
        l += !win[i];
    }

    dfs(1, 0);
    int ans = (1LL * dpW[1].l * l + 1LL * dpW[1].w * w) % MOD;
    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n >> d;
    for (int i = 1 ; i < n ; ++i)
    {
        int u, v;
        std::cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}